#include <iostream>
#include <time.h>		//		function time()
#include <Windows.h>	//		function QueryPerformanceFrequency/Counter()
#include <cmath>		//		function pow()

using namespace std;

double Fibonacci_A(int n) {
	double v;
	if (n <= 0) {
		v = 0.0;
	}
	else if (n == 1) {
		v = 1.0;
	}
	else {
		//	v = Fibonacci(n - 2) + Fibonacci(n - 1);
		double * F = new double[n + 1];
		F[0] = 0.0;
		F[1] = 1.0;
		for (int i = 2; i <= n; i++)
			F[i] = F[i - 2] + F[i - 1];
		v = F[n];
		delete[] F;
	}
	return v;
}

class CFibonacci {
	double * F;
	int isize;
public:
	CFibonacci() {
		F = new double[1001];
		F[0] = 0.0;
		F[1] = 1.0;
		isize = 1;
	}
	virtual ~CFibonacci() {
		delete[] F;
	}
	double operator()(int n) {
		double v;
		if (n <= isize) {
			v = F[n];
		}
		else if (n > 1000) {
			v = -1;
		}
		else {
			for (int i = isize + 1; i <= n; i++)
				F[i] = F[i - 2] + F[i - 1];
			v = F[n];
			isize = n;
		}
		return v;
	}
};

class MyTime {
	LARGE_INTEGER L_I;
	int freq;
	double c;
public:
	MyTime(): c(pow(2.0, 32.0))
	{
		BOOL ck = QueryPerformanceFrequency(&L_I);
		if (ck) {
			freq = L_I.LowPart;
	//		cout << "H = " << L_I.HighPart << "   L = " << L_I.LowPart << endl << endl;
		}
		else {
			freq = -1;
		}
	}
	//		msec
	double operator()() {
		if (freq < 0) {
			return -1.0;
		}
		else {
			QueryPerformanceCounter(&L_I);
			double v = L_I.HighPart * c + L_I.LowPart;
			return 1000.0 * v / freq;
		}
	}
};


int main() {
	double VF[1001];
	time_t t0, t1;
	double dt0, dt1;
	MyTime mt;
	time(&t0);
	dt0 = mt();
	for (int n = 0; n <= 1000; n++) 
		VF[n] = Fibonacci_A(n);	
	time(&t1);
	dt1 = mt();
	for (int n = 990; n <= 1000; n++)
		cout << "Fibonacci(" << n << ") = " << VF[n] << endl;
	cout << "t1 - t0 = " << difftime(t1, t0) << "s" << endl;
	cout << "dt1 - dt0 = " << dt1 - dt0 << "ms" << endl;

	CFibonacci f;
	time(&t0);
	dt0 = mt();
	for (int n = 0; n <= 1000; n++) 
		VF[n] = f(n);
	time(&t1);
	dt1 = mt();
	for (int n = 990; n <= 1000; n++)
		cout << "CFibonacci(" << n << ") = " << VF[n] << endl;
	cout << "t1 - t0 = " << difftime(t1, t0) << "s" << endl;
	cout << "dt1 - dt0 = " << dt1 - dt0 << "ms" << endl;


	cout << endl << "L[ĂAEnterL[ďIB" << endl;
	char ck;
	cin >> ck;
	return 0;
}